// TODO: rename control amd state classes (min, max, modal, focus, ...) #62

import template from "./template.js";
import {
    addListener,
    removeListener,
    setStyle,
    setText,
    getByClass,
    addClass,
    removeClass,
    hasClass,
    preventEvent
} from "./helper.js";

//const ios = /iPad|iPhone|iPod/.test(navigator.userAgent) && !window["MSStream"];

const use_raf = false;
const stack_min = [];
const stack_win = [];
// use passive for touch and mouse wheel
const eventOptions = {"capture": true, "passive": false};
const eventOptionsPassive = {"capture": true, "passive": true};
let body;
let id_counter = 0;
let index_counter = 10;
let is_fullscreen;
let prefix_request;
let prefix_exit;
let root_w, root_h;
let window_clicked;
let rootGlobal;

/**
 * @param {string|Object=} params
 * @param {Object=} _title
 * @constructor
 * @this WinBox
 */
(function(){'use strict';var e,aa=document.createElement("div");aa.innerHTML="<div class=wb-header><div class=wb-control><span class=wb-min></span><span class=wb-max></span><span class=wb-full></span><span class=wb-close></span></div><div class=wb-drag><div class=wb-icon></div><div class=wb-title></div></div></div><div class=wb-body></div><div class=wb-n></div><div class=wb-s></div><div class=wb-w></div><div class=wb-e></div><div class=wb-nw></div><div class=wb-ne></div><div class=wb-se></div><div class=wb-sw></div>";function h(a,b,c,f){a&&a.addEventListener(b,c,f||!1)}function k(a,b){var c=window,f=l;c&&c.removeEventListener(a,b,f||!1)}function m(a,b){a.stopPropagation();b&&a.preventDefault()}function n(a,b,c){c=""+c;a["_s_"+b]!==c&&(a.style.setProperty(b,c),a["_s_"+b]=c)};/*
 self.max &&*/
var u=[],z=[],ba={capture:!0,passive:!1},l={capture:!0,passive:!0},A,ca=0,C=10,E,F,fa,J,K,ha,ia;
function P(a,b){if(!(this instanceof P))return new P(a);A||ja({root:a.root});if(a){if(b){var c=a;a=b}if("string"===typeof a)c=a;else{var f=a.id;var d=a.index;var p=a.root;var q=a.template;c=c||a.title;var w=a.icon;var L=a.mount;var Q=a.html;var g=a.url;var r=a.width;var t=a.height;var v=a.minwidth;var B=a.minheight;var x=a.maxwidth;var y=a.maxheight;var da=a.autosize;var D=a.overflow;var G=a.min;var H=a.max;var I=a.hidden;var ea=a.modal;var W=a.x||(ea?"center":0);var X=a.y||(ea?"center":0);var M=
a.top;var N=a.left;var R=a.bottom;var S=a.right;var ka=a.background;var O=a.border;var T=a.header;var Y=a["class"];var la=a.oncreate;var qa=a.onclose;var ra=a.onfocus;var sa=a.onblur;var ta=a.onmove;var ua=a.onresize;var va=a.onfullscreen;var wa=a.onmaximize;var xa=a.onminimize;var ya=a.onrestore;var za=a.onhide;var Aa=a.onshow;var Ba=a.onload}}this.g=(q||aa).cloneNode(!0);this.g.id=this.id=f||"winbox-"+ ++ca;this.g.className="winbox"+(Y?" "+("string"===typeof Y?Y:Y.join(" ")):"")+(ea?" modal":"");
this.g.winbox=this;this.window=this.g;this.body=this.g.getElementsByClassName("wb-body")[0];this.h=T||35;z.push(this);ka&&this.setBackground(ka);O?n(this.body,"margin",O+(isNaN(O)?"":"px")):O=0;T&&(b=this.g.getElementsByClassName("wb-header")[0],n(b,"height",T+"px"),n(b,"line-height",T+"px"),n(this.body,"top",T+"px"));c&&this.setTitle(c);w&&this.setIcon(w);L?this.mount(L):Q?this.body.innerHTML=Q:g&&this.setUrl(g,Ba);M=M?U(M,K):0;R=R?U(R,K):0;N=N?U(N,J):0;S=S?U(S,J):0;c=J-N-S;w=K-M-R;x=x?U(x,c):c;
y=y?U(y,w):w;v=v?U(v,x):150;B=B?U(B,y):this.h;console.log({m:x,l:y,s:v,o:B});da?((p||A).appendChild(this.body),r=Math.max(Math.min(this.body.clientWidth+2*O+1,x),v),t=Math.max(Math.min(this.body.clientHeight+this.h+O+1,y),B),this.g.appendChild(this.body)):(r=r?U(r,x):Math.max(x/2,v)|0,t=t?U(t,y):Math.max(y/2,B)|0);W=W?U(W,c,r):N;X=X?U(X,w,t):M;this.x=W;this.y=X;this.width=r;this.height=t;this.s=v;this.o=B;this.m=x;this.l=y;this.top=M;this.right=S;this.bottom=R;this.left=N;this.index=d;this.j=D;this.focused=
this.hidden=this.full=this.max=this.min=!1;this.onclose=qa;this.onfocus=ra;this.onblur=sa;this.onmove=ta;this.onresize=ua;this.onfullscreen=va;this.onmaximize=wa;this.onminimize=xa;this.onrestore=ya;this.onhide=za;this.onshow=Aa;I?this.hide():this.focus();if(d||0===d)this.index=d,n(this.g,"z-index",d),d>C&&(C=d);H?this.maximize():G?this.minimize():this.resize().move();ma(this);(p||A).appendChild(this.g);la&&la.call(this,a)}P["new"]=function(a){return new P(a)};P.stack=function(){return z};
function U(a,b,c){"string"===typeof a&&("center"===a?a=(b-c)/2+.5|0:"right"===a||"bottom"===a?a=b-c:(c=parseFloat(a),a="%"===(""+c!==a&&a.substring((""+c).length))?b/100*c+.5|0:c));return a}
function ja(a){A=document.body;ia=a.root||A;A[F="requestFullscreen"]||A[F="msRequestFullscreen"]||A[F="webkitRequestFullscreen"]||A[F="mozRequestFullscreen"]||(F="");fa=F&&F.replace("request","exit").replace("mozRequest","mozCancel").replace("Request","Exit");h(window,"resize",function(){na();oa()});h(A,"mousedown",function(){ha=!1},!0);h(A,"mousedown",function(){if(!ha){var b=z.length;if(b)for(--b;0<=b;b--){var c=z[b];if(c.focused){c.blur();break}}}});na()}
function ma(a){V(a,"drag");V(a,"n");V(a,"s");V(a,"w");V(a,"e");V(a,"nw");V(a,"ne");V(a,"se");V(a,"sw");h(a.g.getElementsByClassName("wb-min")[0],"click",function(b){m(b);a.min?a.restore().focus():a.minimize()});h(a.g.getElementsByClassName("wb-max")[0],"click",function(b){m(b);a.max?a.restore().focus():a.maximize().focus()});F?h(a.g.getElementsByClassName("wb-full")[0],"click",function(b){m(b);a.fullscreen().focus()}):a.addClass("no-full");h(a.g.getElementsByClassName("wb-close")[0],"click",function(b){m(b);
a.close()||(a=null)});h(a.g,"mousedown",function(){ha=!0},!0);h(a.body,"mousedown",function(){a.focus()},!0)}function Z(a){u.splice(u.indexOf(a),1);oa();a.removeClass("min");a.min=!1;a.g.title=""}function oa(){for(var a=u.length,b={},c={},f=0,d;f<a;f++)d=u[f],d=d.left+":"+d.top,c[d]?c[d]++:(b[d]=0,c[d]=1);f=0;for(var p,q;f<a;f++)d=u[f],p=d.left+":"+d.top,q=Math.min((J-d.left-d.right)/c[p],250),d.resize(q+1|0,d.h,!0).move(d.left+b[p]*q|0,K-d.bottom-d.h,!0),b[p]++}
function V(a,b){function c(g){m(g,!0);a.focus();if("drag"===b){if(a.min){a.restore();return}if(!a.g.classList.contains("no-max")){var r=Date.now(),t=r-Q;Q=r;if(300>t){a.max?a.restore():a.maximize();return}}}a.min||(A.classList.add("wb-lock"),(q=g.touches)&&(q=q[0])?(g=q,h(window,"touchmove",f,l),h(window,"touchend",d,l)):(h(window,"mousemove",f,l),h(window,"mouseup",d,l)),w=g.pageX,L=g.pageY)}function f(g){m(g);q&&(g=g.touches[0]);var r=g.pageX;g=g.pageY;var t=r-w,v=g-L,B=a.width,x=a.height,y=a.x,
da=a.y,D;if("drag"===b){if(a.g.classList.contains("no-move"))return;a.x+=t;a.y+=v;var G=D=1}else{if("e"===b||"se"===b||"ne"===b){a.width+=t;var H=1}else if("w"===b||"sw"===b||"nw"===b)a.x+=t,a.width-=t,G=H=1;if("s"===b||"se"===b||"sw"===b){a.height+=v;var I=1}else if("n"===b||"ne"===b||"nw"===b)a.y+=v,a.height-=v,D=I=1}H&&(a.width=Math.max(Math.min(a.width,a.m,J-a.x-a.right),a.s),H=a.width!==B);I&&(a.height=Math.max(Math.min(a.height,a.l,K-a.y-a.bottom),a.o),I=a.height!==x);(H||I)&&a.resize();G&&
(a.max&&(a.x=(r<J/3?a.left:r>J/3*2?J-a.width-a.right:J/2-a.width/2)+t),a.x=Math.max(Math.min(a.x,a.j?J-30:J-a.width-a.right),a.j?30-a.width:a.left),G=a.x!==y);D&&(a.max&&(a.y=a.top+v),a.y=Math.max(Math.min(a.y,a.j?K-a.h:K-a.height-a.bottom),a.top),D=a.y!==da);if(G||D)a.max&&a.restore(),a.move();if(H||G)w=r;if(I||D)L=g}function d(g){m(g);A.classList.remove("wb-lock");q?(k("touchmove",f),k("touchend",d)):(k("mousemove",f),k("mouseup",d))}var p=a.g.getElementsByClassName("wb-"+b)[0];if(p){var q,w,L,
Q=0;h(p,"mousedown",c,ba);h(p,"touchstart",c,ba)}}function na(){J=(ia||A).clientWidth;K=(ia||A).clientHeight}e=P.prototype;e.mount=function(a){this.unmount();a.i||(a.i=a.parentNode);this.body.textContent="";this.body.appendChild(a);return this};e.unmount=function(a){var b=this.body.firstChild;if(b){var c=a||b.i;c&&c.appendChild(b);b.i=a}return this};e.setTitle=function(a){var b=this.g.getElementsByClassName("wb-title")[0];a=this.title=a;var c=b.firstChild;c?c.nodeValue=a:b.textContent=a;return this};
e.setIcon=function(a){var b=this.g.getElementsByClassName("wb-icon")[0];n(b,"background-image","url("+a+")");n(b,"display","inline-block");return this};e.setBackground=function(a){n(this.g,"background",a);return this};e.setUrl=function(a,b){var c=this.body.firstChild;c&&"iframe"===c.tagName.toLowerCase()?c.src=a:(this.body.innerHTML='<iframe src="'+a+'"></iframe>',b&&(this.body.firstChild.onload=b));return this};
e.focus=function(a){if(!1===a)return this.blur();if(!this.focused){a=z.length;if(1<a)for(var b=1;b<=a;b++){var c=z[a-b];if(c.focused){c.blur();z.push(z.splice(z.indexOf(this),1)[0]);break}}n(this.g,"z-index",++C);this.index=C;this.addClass("focus");this.focused=!0;this.onfocus&&this.onfocus()}return this};e.blur=function(a){if(!1===a)return this.focus();this.focused&&(this.removeClass("focus"),this.focused=!1,this.onblur&&this.onblur());return this};
e.hide=function(a){if(!1===a)return this.show();if(!this.hidden)return this.onhide&&this.onhide(),this.hidden=!0,this.addClass("hide")};e.show=function(a){if(!1===a)return this.hide();if(this.hidden)return this.onshow&&this.onshow(),this.hidden=!1,this.removeClass("hide")};
e.minimize=function(a){if(!1===a)return this.restore();E&&pa();this.max&&(this.removeClass("max"),this.max=!1);this.min||(u.push(this),oa(),this.g.title=this.title,this.addClass("min"),this.min=!0,this.focused&&(this.blur(),Ca()),this.onminimize&&this.onminimize());return this};function Ca(){var a=z.length;if(a)for(--a;0<=a;a--){var b=z[a];if(!b.min){b.focus();break}}}
e.restore=function(){E&&pa();this.min&&(Z(this),this.resize().move(),this.onrestore&&this.onrestore());this.max&&(this.max=!1,this.removeClass("max").resize().move(),this.onrestore&&this.onrestore());return this};e.maximize=function(a){if(!1===a)return this.restore();E&&pa();this.min&&Z(this);this.max||(this.addClass("max").resize(J-this.left-this.right,K-this.top-this.bottom,!0).move(this.left,this.top,!0),this.max=!0,this.onmaximize&&this.onmaximize());return this};
e.fullscreen=function(a){this.min&&(Z(this),this.resize().move());if(!E||!pa())this.body[F](),E=this,this.full=!0,this.onfullscreen&&this.onfullscreen();else if(!1===a)return this.restore();return this};function pa(){E.full=!1;if(document.fullscreen||document.fullscreenElement||document.webkitFullscreenElement||document.mozFullScreenElement)return document[fa](),!0}
e.close=function(a){if(this.onclose&&this.onclose(a))return!0;this.min&&Z(this);z.splice(z.indexOf(this),1);this.unmount();this.g.remove();this.g.textContent="";this.g=this.body=this.g.winbox=null;this.focused&&Ca()};e.move=function(a,b,c){a||0===a?c||(this.x=a?a=U(a,J-this.left-this.right,this.width):0,this.y=b?b=U(b,K-this.top-this.bottom,this.height):0):(a=this.x,b=this.y);n(this.g,"left",a+"px");n(this.g,"top",b+"px");this.onmove&&this.onmove(a,b);return this};
e.resize=function(a,b,c){a||0===a?c||(this.width=a?a=U(a,this.m):0,this.height=b?b=U(b,this.l):0,a=Math.max(a,this.s),b=Math.max(b,this.o)):(a=this.width,b=this.height);n(this.g,"width",a+"px");n(this.g,"height",b+"px");this.onresize&&this.onresize(a,b);return this};
e.addControl=function(a){var b=a["class"],c=a.image,f=a.click;a=a.index;var d=document.createElement("span"),p=this.g.getElementsByClassName("wb-control")[0],q=this;b&&(d.className=b);c&&n(d,"background-image","url("+c+")");f&&(d.onclick=function(w){f.call(this,w,q)});p.insertBefore(d,p.childNodes[a||0]);return this};e.removeControl=function(a){(a=this.g.getElementsByClassName(a)[0])&&a.remove();return this};e.addClass=function(a){this.g.classList.add(a);return this};
e.removeClass=function(a){this.g.classList.remove(a);return this};e.toggleClass=function(a){return this.g.classList.contains(a)?this.removeClass(a):this.addClass(a)};window.WinBox=P;}).call(this);
